<template>
  <view class="page-picking-order">
    <view class="header">
      <view class="left">
        <u-icon class="icon" name="arrow-left" @click="uni.navigateBack()" />
      </view>
      <view class="title">{{ $t('message.Pi_SummaryPicking') }}</view>
      <view class="right"></view>
    </view>
    <!-- 列表展示数据 -->
    <view class="table-wrapper">
      <wyb-table class="table" ref="table" width="100%" enable-check="single" show-left-and-right-border :headers="headers" :contents="model.aggregateList" :show-vert-border="false" @onCheck="handleRow"></wyb-table>
    </view>
    <!-- 展示详细信息 -->
    <view class="Exhibition">
      <view class="Exhibition-left">
        <view class="Exhibition-left-title">{{ $t('message.Pi_Station') }}:</view>
        <view class="Exhibition-left-data">{{ some.sendSpot }}</view>
      </view>
      <view class="Exhibition-right">
        <view class="Exhibition-right-title">{{ $t('message.Pi_PickedQuantity') }}:</view>
        <view class="Exhibition-right-data">{{ some.totalMoAmount }}</view>
      </view>
    </view>
    <!-- 添加库位 -->
    <view class="library">
      <view class="library-left">
        <view>{{ $t('message.CommissionedLocation') }}:</view>
        <jPicker sureColor="#ff0000" style="width: 230rpx" @bindpicker="LocationChoice" showKey="value" valKey="value" :val="wlCode.value" class="search" :options="Location" />
      </view>
      <view class="library-right">
        <view class="library-right-title">{{ $t('message.CommissionedThisNumber') }}:</view>
        <u-input v-model="qty" type="number" :border="border" :placeholder="$t('message.Summary_PleaseInputNumber')" class="input" />
      </view>
    </view>
    <!-- 添加 -->
    <view class="add">
      <u-button type="primary" @click="Add">{{ $t('message.product_add') }}</u-button>
    </view>
    <!-- 表格 -->
    <u-table class="library-table">
      <u-tr class="u-tr">
        <u-th class="u-th">{{ $t('message.product_Location') }}</u-th>
        <u-th class="u-th">{{ $t('message.product_Number') }}</u-th>
        <u-th class="u-th">{{ $t('message.operation') }}</u-th>
      </u-tr>
      <u-tr class="u-tr" v-for="(item, index) in LocationList" :key="index">
        <u-td class="u-td">{{ item.wlCode }}</u-td>
        <u-td class="u-td">{{ item.qty }}</u-td>
        <u-td class="u-td">
          <u-button type="error" size="small" style="font-size: 20px" @click="deleteItem(index)">{{ $t('message.product_Delete') }}</u-button>
        </u-td>
      </u-tr>
    </u-table>
    <view class="bottom-bar">
      <div class="extra">
        <u-form ref="form" :model="form" :error-type="['toast']">
          <u-row class="bottom-info"> </u-row>
        </u-form>
      </div>
      <div class="container">
        <u-row>
          <u-col :span="4">
            <u-button type="primary" class="appoint" @click="bill">{{ $t('message.detailed') }}</u-button>
          </u-col>
          <u-col :span="4">
            <u-button type="success" @click="onSubmit">
              {{ $t('message.po_Submit') }}
            </u-button>
          </u-col>
          <u-col :span="4">
            <u-button type="error" @click="uni.navigateBack()">
              {{ $t('message.po_Return') }}
            </u-button>
          </u-col>
        </u-row>
      </div>
    </view>
  </view>
</template>
<script lang="ts">
import { Component, Ref } from 'vue-property-decorator';
import { BasePage } from '@/components/base/page';
import model from './model';
import { summaryHeaders } from './config';
import { session } from '@/store/modules/session';
import { VForm, VFormRules } from 'vue/types/form';
import jPicker from '@/components/J-Picker/jPicker.vue';
import { pick } from 'lodash/fp';
@Component({
  components: {
    jPicker,
  },
})
export default class RawReceiptDetail extends BasePage {
  @Ref('form') readonly $form!: VForm;
  @Ref('submitForm') readonly $submitForm!: VForm;
  submitForm = {
    receiver: '',
    receiverName: '',
    password: '',
  };
  model = model;
  type = 'text';
  wlCode: any = '';
  border = true;
  //添加库位和数量的列表
  LocationList: any = [];
  //库位
  Location: any = [];
  someIndex: number = 0;
  some: any = {};
  qty: any = '';
  //表单数据
  form: any = {
    // locationCode: null,
    amount: null,
  };
  /**
   * 表单校验
   */
  rules: VFormRules<any> = {
    // locationCode: [{ required: true, message: '请选择库存地点！' }],
    amount: [
      { required: true, message: this.$t('message.Pi_tip1') as string },
      // { type: 'integer', min: 1, transform: Number, message: this.$t('message.Pi_tip2') as string },
    ],
  };

  /**
   * 库存地点选择
   */
  locationCodeSelect = false;
  //表头
  headers = summaryHeaders;
  //选择库位
  LocationChoice(e: any) {
    console.log('e>>>>>>>>>>>>>>>>>>>>>>>>', e);
    this.wlCode = e.pickerName;
  }
  //选取某一条需要分配库位的物料数据
  handleRow({ data }: any) {
    if (!this.model.aggregateList[data[0].index].sendSpot) {
      uni.showModal({
        content: this.$t('message.SAPLocation') as any,
        confirmText: this.$t('message.workArea_Confirm') as string,
        cancelText: this.$t('message.Cancel') as string,
        success: (res) => {
          if (res.confirm) {
            this.model.aggregateList[data[0].index].checked = false;
          }
        },
      });
      return;
    }
    this.someIndex = data[0].index;
    this.some = data[0].lineData;
    this.model.aggregateList[this.someIndex].wlList = [];
    this.model.aggregateList[this.someIndex].currentAmount = 0;
    this.LocationList = [];
    this.qty = '';
  }
  //添加库位和数量到数据和表格中
  Add() {
    if (this.qty == '' || this.wlCode == '') {
      this.customToast(this.$t('message.Commission_tips2') as any);
      return;
    }
    if (parseFloat(this.qty) <= 0) {
      this.customToast(this.$t('message.Commission_tips3') as any);
      return;
    }
    //guoshuang 判断对象为空修改 逻辑：订单勾选校验
    if (JSON.stringify(this.some) == '{}') {
      this.customToast(this.$t('message.Commission_tips6') as any);
      return;
    }
    let isTrue = true;
    if (this.LocationList.length != 0) {
      this.LocationList.forEach((item: any) => {
        if (this.wlCode.sendSpot != item.Code) {
          this.customToast(this.$t('message.Commission_tips7') as any);
          return (isTrue = false);
        }
      });
    }
    if (isTrue == true) {
      if (parseFloat(this.qty) + parseFloat(this.some.totalMoAmount) > parseFloat(this.some.amount)) {
        uni.showModal({
          title: 'Tip',
          content: this.$t('message.Pi_tip11') as string,
          confirmText: this.$t('message.workArea_Confirm') as string,
          cancelText: this.$t('message.Cancel') as string,
          showCancel: true,
          success: (res) => {
            if (res.confirm) {
              let arr = {
                wlCode: this.wlCode.label,
                qty: this.qty,
                Code: this.wlCode.sendSpot,
              };
              this.LocationList.push(arr);
              let objString = JSON.stringify(this.some);
              let TEM = JSON.parse(objString);
              TEM.wlList = null;
              TEM.wlCode = this.wlCode.label;
              TEM.qty = this.qty;
              this.model.aggregateList[this.someIndex].wlList.push(TEM);
              this.model.aggregateList[this.someIndex].currentAmount += parseFloat(this.qty);
              this.qty = '';
            }
          },
        });
      } else {
        let arr = {
          wlCode: this.wlCode.label,
          qty: this.qty,
          Code: this.wlCode.sendSpot,
        };
        this.LocationList.push(arr);
        let objString = JSON.stringify(this.some);
        let TEM = JSON.parse(objString);
        TEM.wlList = null;
        TEM.wlCode = this.wlCode.label;
        TEM.qty = this.qty;
        this.model.aggregateList[this.someIndex].wlList.push(TEM);
        this.model.aggregateList[this.someIndex].currentAmount += parseFloat(this.qty);
        this.qty = '';
      }
    }
  }
  //表格执行删除操作
  deleteItem(index: any) {
    this.LocationList.splice(index, 1);
    this.model.aggregateList[this.someIndex].wlList.splice(index, 1);
    this.business();
  }
  //确保每次表格执行删除操作  单条数据汇总总数实时改变
  business() {
    let num: number = 0;
    this.LocationList.forEach((item: any) => {
      num += parseFloat(item.qty);
    });
    this.model.aggregateList[this.someIndex].currentAmount = num;
  }
  async onReady() {
    await this.onAggregate();
    await this.GetLocation();
  }
  async bill() {
    this.redirectTo(this.page.raw.handover.picking.SummaryLocal);
  }
  //点击提交 上传数据
  async onSubmit() {
    const includeOrderOutIdList = this.model.proOrderResultList.map((_: any) => _.orderOutId);
    const dataList: any = [];
    this.model.aggregateList.forEach((item: any) => {
      if (item.checked == true) {
        dataList.push(item);
      }
    });
    if (dataList.length == 0) {
      this.customToast(this.$t('message.Warehouse_Tip6') as any);
      return;
    }
    const params = {
      factoryCode: session.factoryCode,
      loginName: session.loginName,
      dataList,
      includeOrderOutIdList,
    };
    await this.model.saveAggregateUpload(params);
    if (this.model.code == '1') {
      this.customToast(this.$t('message.Warehouse_Tip9') as any);
      this.GetLocation();
      setTimeout(() => {
        this.onAggregate();
      }, 2000);
    }
  }
  async onAggregate() {
    await this.model.queryProOrder(this.model.formParams);
    await this.model.queryProOrderResult(this.model.NEWparams);
    const orderOutIdList = this.model.proOrderResultList.map((_: any) => _.orderOutId);
    const params = {
      factoryCode: session.factoryCode,
      loginName: session.loginName,
      orderOutIdList,
    };
    await this.model.queryAggregateList(params);
    this.some = {};
    this.LocationList = [];
    this.wlCode = '';
  }
  async GetLocation() {
    this.Location = [];
    let means: any = JSON.parse(localStorage.getItem('__GWMS_APP_STATE_DATA__') as any);
    let sendSpot = JSON.parse(localStorage.getItem('sendSpot') as any);
    let content = {
      loginName: means.session.user.loginName,
      sendSpot: sendSpot,
      factoryCode: means.session.user.factoryCode,
      workArea: session.workareaCode,
    };
    let res: any = await this.model.queryByFactoryCodeAndWorkAreaCode(content);
    res.forEach((item: any) => {
      let pickerName: any = {};
      pickerName.label = item.locationCode;
      pickerName.value = item.locationCode + '(' + item.sendSpot + ')';
      pickerName.sendSpot = item.sendSpot;
      this.Location.push(pickerName);
    });
  }
}
</script>

<style lang="scss" scoped>
.page-picking-order {
  background: #f2f2f2 linear-gradient(0deg, #eee7e7 0%, #4a78ea 51%, #1753ea 100%) no-repeat;
  background-size: 100% 600rpx;
  padding: 30rpx;
  min-height: 100%;
  padding-top: 118rpx;
  padding-bottom: 222rpx;

  .header {
    position: fixed;
    top: 36rpx;
    left: 0;
    right: 0;
    display: flex;
    height: 88rpx;
    line-height: 88rpx;
    color: #fff;
    font-size: 34rpx;
    font-weight: 500;
    text-align: center;
    .title {
      flex: 3;
    }
    .left,
    .right {
      flex: 1;
    }
    .icon {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 88rpx;
      height: 88rpx;
    }
  }

  .table-wrapper {
    background-color: #fff;
    height: 500rpx;
    overflow-x: auto;
  }

  .form {
    background-color: #fff;
    padding: 40rpx;
    border-radius: 10rpx;
  }
  .Exhibition {
    width: 100%;
    height: 100rpx;
    margin-top: 20rpx;
    display: flex;
    .Exhibition-left {
      width: 50%;
      height: 100%;
      display: flex;
      .Exhibition-left-title {
        width: 50%;
        height: 100%;
        text-align: center;
        line-height: 100rpx;
      }
      .Exhibition-left-data {
        width: 50%;
        height: 100%;
        text-align: center;
        line-height: 100rpx;
      }
    }
    .Exhibition-right {
      width: 50%;
      height: 100%;
      display: flex;
      .Exhibition-right-title {
        width: 50%;
        height: 100%;
        text-align: left;
        line-height: 100rpx;
      }
      .Exhibition-right-data {
        width: 50%;
        height: 100%;
        text-align: center;
        line-height: 100rpx;
      }
    }
  }
  .library {
    width: 100%;
    height: 100rpx;
    display: flex;
    .library-left {
      width: 50%;
      height: 100%;
      display: flex;
      view {
        width: 230rpx;
        line-height: 100rpx;
        text-align: center;
      }
    }
    .library-right {
      width: 50%;
      height: 100%;
      display: flex;
      .library-right-title {
        width: 120rpx;
        height: 100%;
        line-height: 100rpx;
        text-align: center;
      }
      .input {
        width: 200rpx;
        height: 70rpx;
        margin-top: 15rpx;
        margin-left: 15rpx;
      }
    }
  }
  .add {
    width: 100%;
    height: 100rpx;
    position: relative;
    button {
      position: absolute;
      top: 10rpx;
      right: 20rpx;
    }
  }
  .bottom-bar {
    z-index: 21;
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;

    .container {
      background: #ffffff;
      box-shadow: 0 1rpx 20rpx 0 rgba(128, 128, 128, 0.2);
      padding: 20rpx;
    }

    .extra {
      background-color: #fff;
      margin: 5px;
      border-radius: 5px;
      padding: 0 10px;
    }

    .bottom-info {
      .u-form-item {
        padding: 0;
      }
    }
  }
}
</style>
